<?php
function simpletestauto_test_insert($node) {
  if ($node->file) {
    $file = file_save_upload($node->file, file_directory_path());
    $node->patch_url = file_create_url($file->filepath);
  }
  db_query("INSERT INTO {simpletestauto_test} (nid, project, patch_url, version, test_status, file_path, file_mime, file_size, issue_id, submitter) VALUES (%d, '%s', '%s', '%s', '%d', '%s', '%s', '%d', '%d', '%s')", $node->nid, $node->project, $node->patch_url,$node->version, $node->test_status, $file->filepath, $file->filemime, $file->filesize, $node->issue_id, $node->submitter);
  
  
//  // we send test to test server
//  $server_url  = variable_get('simpletestauto_server_url', '$base_url/xmlrpc.php');
//  $server_pwd = sha1(variable_get('simpletestauto_server_pwd', ''));
//  $msg = xmlrpc($server_url, 'simpletestautoServer.testPatch', $server_pwd, $node->nid);
//  if (stristr($msg,'Error')) {
//	drupal_set_message(t($msg), 'error');
//  }
//  else if ($msg) {
//    $new_url = url('node/'.$node->nid, NULL, NULL, TRUE);
//    drupal_set_message(t('Your patch has been successfully submitted for testing, and will be tested the next time the automated tests run.'));  	  
//  }
//  else {
//    $err_no = xmlrpc_error_msg();
//  	drupal_set_message(t('There was an error durring your request. Error: '.$err_no),'error');
//  }	
}

function simpletestauto_test_update($node) {
  db_query("UPDATE {simpletestauto_test} SET project = '%s', patch_url = '%s', version = '%s', test_status = '%d' WHERE nid = %d", $node->project, $node->patch_url, $node->version, $node->test_status, $node->nid);
}

function simpletestauto_test_load($node) {
  $test = db_fetch_object(db_query('SELECT * FROM {simpletestauto_test} WHERE nid = %d', $node->nid));
  return $test;
}

function simpletestauto_test_delete($node) {
  db_query('DELETE FROM {simpletestauto_test} WHERE nid = %d', $node->nid);
}

function simpletestauto_test_form(&$node) {
  global $drupal_releases;
  
  // after the test is tested editing is disabled
  if ($node->test_status != SIMPLETESTAUTO_NOT_TESTED) {
    $disabled = true;
  }
  else {
    $disabled = false;
  }
  $form['#attributes'] = array("enctype" => "multipart/form-data");
  $form['title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#required' => TRUE,
    '#default_value' => $node->title,
    '#weight' => -5
  );
 $form['body_filter']['body'] = array(
    '#type' => 'textarea',
    '#description' => 'You can leave this empty or write some notes about your patch.',
    '#title' => t('Body'),
    '#default_value' => $node->body,
    '#required' => FALSE,
    '#disabled' => $disabled,
  );
  $form['body_filter']['filter'] = filter_form($node->format);

  $form['project'] = array(
    '#type' => 'hidden',
    '#title' => t('Project name'),
    '#description' => t('Which project is this patch for. If project is drupal core than write Drupal'),
    '#default_value' => 'Drupal',
    '#required' => TRUE,
    '#disabled' => $disabled,
  );
  $drupal_releases = array(
    'HEAD' => 'HEAD',
    'DRUPAL-5' => 'Drupal 5 dev',
    'DRUPAL-5-1' => 'Drupal 5.1',
  );
  $form['version'] = array(
    '#type' => 'select',
    '#title' => t('Version'),
    '#default_value' => (isset($node->version) ? $node->version : 'HEAD') ,
    '#options' => $drupal_releases,
    '#required' => TRUE,
    '#disabled' => $disabled,
  );
  
  $form['patch_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Patch URL'),
    '#default_value' => $node->patch_url,
    '#description' => "Enter patch url here or upload patch.",
    '#disabled' => $disabled,    
  );
  if (!isset($node->patch_url)) {
  	$form['patch_file'] = array(
      '#type' => 'file',
      '#title' => t('File attachment'),
      '#size' => 40,
      '#description' => ($node->patch_file || $node->patch_file ? t('A file already exists, if you upload another file the current file will be replaced.') : t('Attach a patch.')),
    );
  }

  return $form;
}

function simpletestauto_test_node_form_validate($form_id, $form) {
  global $form_values;
  $edit = $_POST['edit'];
  $file = file_check_upload('patch_file');
  if ($form_values['patch_url'] == "" && $file == NULL) {
    form_set_error('patch_url', t('Please provide a patch url or upload a new file.'));
  }
  $form_values['file'] = file_save_upload($file);
}

/**
 * Implementation of hook_content().
 */
function simpletestauto_test_content($node, $teaser = false) {
  $node = node_prepare($node, $teaser);
  return $node;
}


function simpletestauto_test_view(&$node, $teaser = false, $page = false) {
  $node = node_prepare($node, $teaser);
  
  if (!$teaser && $page) {

    $rows = array();
    $rows[] = array('Project: ', check_plain($node->project));
    $rows[] = array('Version: ', check_plain($node->version));
    $rows[] = array(t('Patch url: '),  l($node->patch_url, $node->patch_url));
    $issue_url = "http://drupal.org/node/" . $node->issue_id;
    $rows[] = array(t('Drupal.org issue: '), l($issue_url, $issue_url));
    $rows[] = array(t('Patch by: '), $node->submitter);
    if ($node->site_url) {
      $rows[] = array(t('Test site: '), l($node->site_url, $node->site_url));
    }
    switch ($node->test_status) {
      case SIMPLETESTAUTO_PASS:
        $status = t('PASSED');
        break;
      case SIMPLETESTAUTO_FAIL:
        $status = t('FAILED');
        break;
      case SIMPLETESTAUTO_NOT_TESTED:
        $status = t('NOT TESTED');
        break;
      case SIMPLETESTAUTO_SUBMITED:
        $status = t('SUBMITED TO TEST SERVER');
        break;
      case SIMPLETESTAUTO_IN_PROGRESS:
        $status = t('TESTING IN PROGRESS');
        break;    
    }
    $rows[] = array(t('Status: '), $status);
    $node->content['test_summary'] = array(
      '#value' => '<div class="summary">' . theme('table', array(), $rows) . '</div>',
      '#weight' => -5,
    );
  }
  return $node;
}

function simpletestauto_test_access($op, $node) {
  global $user;
  if ($op == 'create') {
    // if server is not used to catch patches nobody is allowed to create patch node
    if (variable_get('simpletestauto_catch_patch',0)) {
      return user_access('create simpletestauto_test');
    }
    else {
      return FALSE;
    }
  }
  
  if ($op == 'update' || $op == 'delete') {
  	if (user_access('edit own simpletestauto_test')  && ($user->uid == $node->uid)) {
  	  return TRUE;
  	}
  }
}
?>
